Package org.eclipse.birt.report.model.api.elements.structures

# Class ColumnHint

java.lang.Object
org.eclipse.birt.report.model.core.Structure
org.eclipse.birt.report.model.core.PropertyStructure
org.eclipse.birt.report.model.api.elements.structures.ColumnHint

All Implemented Interfaces:
  `Cloneable`, `IStructure`, `org.eclipse.birt.report.model.core.IPropertySet`

public class ColumnHint extends org.eclipse.birt.report.model.core.PropertyStructure
This class represents one column hint used by data sets.

This is a managed object, meaning that all changes should be made though the command layer so that they can be undone and redone. Each column hint has the following properties:

Column Name
  a column hint has a required name. It keys the column hint to a column within the result set.
Alias
  a column hint has an optional alias. It provides an 'alias' name used for the column within the report.
Searching
  a column hint has an optional searching. It indicates how the column will be used when searching.
Export
  a column hint has an optional export. It determines how the column will be used when exporting data.
Analysis
  a column hint has an optional analysis. It determines how the column is used when exporting the data to an OLAP cube.
Parent Level
  a column hint has an optional parent level. It is used when a column's `ANALYSIS_MEMBER` property is set to `ANALYSIS_TYPE_DIMENSION` or `ANALYSIS_TYPE_DETAIL`. For `ANALYSIS_TYPE_DIMENSION`, this property establishes the dimension hierarchy.
Format
  a column hint has an optional format. It is used to format the column data when displaying the value in the viewing UI, especially within the search results.
Display Name
  a column hint has an optional display name. It provides an optional localizable display name for the column.
Display Name ID
  a column hint has an optional display name ID. It provides the key to localize the display name.
Help Text
  a column hint has an optional help text. It provides an optional localizable descriptive text that explains the column to the end user.
Help Text ID
  a column hint has an optional help text ID. It provides the key to localize the help text.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ACL_EXPRESSION_MEMBER`
Name of the member that defines expression to calculate ACL for the data set column.
`static final String`
`ACTION_MEMBER`
Name of the member that defines the action structure of result set column and computed column.
`static final String`
`ALIAS_MEMBER`
Name of the alias member.
`static final String`
`ANALYSIS_COLUMN_MEMBER`
Name of the member which used to associate a field to the selected field when the analysisType is attribute.
`static final String`
`ANALYSIS_MEMBER`
Name of the analysis member.
`static final String`
`COLUMN_HINT_STRUCT`
Name of this structure.
`static final String`
`COLUMN_NAME_MEMBER`
Name of the column name member.
`static final String`
`COMPRESSED_MEMBER`
Name of the member that indicates whether the column needs to be compressed.
`static final String`
`DESCRIPTION_ID_MEMBER`
Deprecated.
`static final String`
`DESCRIPTION_MEMBER`
Deprecated.
`static final String`
`DISPLAY_LENGTH_MEMBER`
Deprecated.
`static final String`
`DISPLAY_NAME_ID_MEMBER`
Name of the display name ID member.
`static final String`
`DISPLAY_NAME_MEMBER`
Name of the display name member.
`static final String`
`EXPORT_MEMBER`
Name of the export member.
`static final String`
`FORMAT_MEMBER`
Deprecated.
`static final String`
`HEADING_ID_MEMBER`
Name of the heading id member.
`static final String`
`HEADING_MEMBER`
Name of the heading member.
`static final String`
`HELP_TEXT_ID_MEMBER`
Name of the help text ID member.
`static final String`
`HELP_TEXT_MEMBER`
Name of the help text member.
`static final String`
`HORIZONTAL_ALIGN_MEMBER`
Name of the horizontal alignment member.
`static final String`
`INDEX_COLUMN_MEMBER`
Name of the member that indicates whether the column should be generated with index.
`static final String`
`ON_COLUMN_LAYOUT_MEMBER`
Name of the on column layout member.
`static final String`
`PARENT_LEVEL_MEMBER`
Name of the parent level member.
`static final String`
`SEARCHING_MEMBER`
Name of the searching member.
`static final String`
`TEXT_FORMAT_MEMBER`
Deprecated.
`static final String`
`VALUE_FORMAT_MEMBER`
Name of the member that defines the format of value.
`static final String`
`WORD_WRAP_MEMBER`
Deprecated.

### Fields inherited from class org.eclipse.birt.report.model.core.PropertyStructure

`propValues`

## Constructor Summary

Constructors
Constructor
Description
`ColumnHint()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getStructName()`
Returns the name of the structure definition.
`StructureHandle`
`handle(SimpleValueHandle valueHandle, int index)`
Creates the specific handle of this structure.
`List<SemanticException>`
`validate(org.eclipse.birt.report.model.core.Module module, org.eclipse.birt.report.model.core.DesignElement element)`
Validates this structure.

### Methods inherited from class org.eclipse.birt.report.model.core.PropertyStructure

`clone, getIntrinsicProperty, getLocalProperty, getLocalProperty, setIntrinsicProperty, setProperty`

### Methods inherited from class org.eclipse.birt.report.model.core.Structure

`checkStringMember, copy, equals, getCompatibleValue, getContext, getDefn, getElement, getExpressionProperty, getHandle, getHandle, getMemberDefn, getObjectDefn, getProperty, getProperty, getReferencableProperty, getStringProperty, isDesignTime, isReferencable, setContext, setExpressionProperty, setProperty, setupContext, updateReference`

### Methods inherited from class java.lang.Object

`finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### COLUMN_HINT_STRUCT

public static final String COLUMN_HINT_STRUCT
Name of this structure. Matches the definition in the meta-data dictionary.

See Also:
  - Constant Field Values

### COLUMN_NAME_MEMBER

public static final String COLUMN_NAME_MEMBER
Name of the column name member. This member keys the column hint to a column within the result set.

See Also:
  - Constant Field Values

### ALIAS_MEMBER

public static final String ALIAS_MEMBER
Name of the alias member. This member provides an 'alias' name used for the column within the report.

See Also:
  - Constant Field Values

### SEARCHING_MEMBER

public static final String SEARCHING_MEMBER
Name of the searching member. This member indicates how the column will be used when searching.

See Also:
  - Constant Field Values

### EXPORT_MEMBER

public static final String EXPORT_MEMBER
Name of the export member. This member determines how the column will be used when exporting data.

See Also:
  - Constant Field Values

### ANALYSIS_MEMBER

public static final String ANALYSIS_MEMBER
Name of the analysis member. This member determines how the column is used when exporting the data to an OLAP cube. OLAP cubes require that the columns be structured into dimension hierarchies. Such hierarchies are formed though a sequence of dimensions. The intersection of hierarchies have one or more numeric measures. Columns that are neither dimensions or measures can be details that associated with a dimension. Whether any given column is actually available for use with analysis depends on the `EXPORT_MEMBER` property above.

See Also:
  - Constant Field Values

### PARENT_LEVEL_MEMBER

public static final String PARENT_LEVEL_MEMBER
Name of the parent level member. This member is used when a column's `ANALYSIS_MEMBER` property is set to `ANALYSIS_TYPE_DIMENSION` or `ANALYSIS_TYPE_DETAIL` . For `ANALYSIS_TYPE_DIMENSION`, this property establishes the dimension hierarchy. Lower (more detailed) dimensions identify their parent (more general) dimensions. For `ANALYSIS_TYPE_DETAIL`, this property identifies the dimension for which this column is a detail.

See Also:
  - Constant Field Values

### FORMAT_MEMBER

@Deprecated public static final String FORMAT_MEMBER
Deprecated.
Name of the format member. This member is used to format the column data when displaying the value in the viewing UI, especially within the search results.

See Also:
  - Constant Field Values

### DISPLAY_NAME_ID_MEMBER

public static final String DISPLAY_NAME_ID_MEMBER
Name of the display name ID member. This member provides the resource key for display name.

See Also:
  - Constant Field Values

### DISPLAY_NAME_MEMBER

public static final String DISPLAY_NAME_MEMBER
Name of the display name member. This member provides the an optional localizable display name for the column.

See Also:
  - Constant Field Values

### HELP_TEXT_ID_MEMBER

public static final String HELP_TEXT_ID_MEMBER
Name of the help text ID member. This member provides the resource key for help text.

See Also:
  - Constant Field Values

### HELP_TEXT_MEMBER

public static final String HELP_TEXT_MEMBER
Name of the help text member. This member provides an optional localizable descriptive text that explains the column to the end user.

See Also:
  - Constant Field Values

### ON_COLUMN_LAYOUT_MEMBER

public static final String ON_COLUMN_LAYOUT_MEMBER
Name of the on column layout member. This member is a hint on how the dimension data element should be layout on column or row.

See Also:
  - Constant Field Values

### HEADING_MEMBER

public static final String HEADING_MEMBER
Name of the heading member. The member provides an optional localizable heading of the column.

See Also:
  - Constant Field Values

### HEADING_ID_MEMBER

public static final String HEADING_ID_MEMBER
Name of the heading id member. The member provides the resource key for heading

See Also:
  - Constant Field Values

### DISPLAY_LENGTH_MEMBER

@Deprecated public static final String DISPLAY_LENGTH_MEMBER
Deprecated.
Name of the display length member. This member indicates how long texts to display.

See Also:
  - Constant Field Values

### HORIZONTAL_ALIGN_MEMBER

public static final String HORIZONTAL_ALIGN_MEMBER
Name of the horizontal alignment member. This member provides the text order of the column.

See Also:
  - Constant Field Values

### WORD_WRAP_MEMBER

@Deprecated public static final String WORD_WRAP_MEMBER
Deprecated.
Name of the word wrap member. This member indicates if the word need to be wrapped.

See Also:
  - Constant Field Values

### TEXT_FORMAT_MEMBER

@Deprecated public static final String TEXT_FORMAT_MEMBER
Deprecated.
Name of the text format member. This member provides the text format of the column.

See Also:
  - Constant Field Values

### DESCRIPTION_MEMBER

@Deprecated public static final String DESCRIPTION_MEMBER
Deprecated.
Name of the description member. The member provides an optional localizable description of the column.

See Also:
  - Constant Field Values

### DESCRIPTION_ID_MEMBER

@Deprecated public static final String DESCRIPTION_ID_MEMBER
Deprecated.
Name of the description id member. The member provides the resource key for the description.

See Also:
  - Constant Field Values

### ACTION_MEMBER

public static final String ACTION_MEMBER
Name of the member that defines the action structure of result set column and computed column.

See Also:
  - Constant Field Values

### ACL_EXPRESSION_MEMBER

public static final String ACL_EXPRESSION_MEMBER
Name of the member that defines expression to calculate ACL for the data set column. This expression is evaluated once for each column, after the data set has been executed but before the first result set row has been processed.

See Also:
  - Constant Field Values

### ANALYSIS_COLUMN_MEMBER

public static final String ANALYSIS_COLUMN_MEMBER
Name of the member which used to associate a field to the selected field when the analysisType is attribute.

See Also:
  - Constant Field Values

### VALUE_FORMAT_MEMBER

public static final String VALUE_FORMAT_MEMBER
Name of the member that defines the format of value.

See Also:
  - Constant Field Values

### INDEX_COLUMN_MEMBER

public static final String INDEX_COLUMN_MEMBER
Name of the member that indicates whether the column should be generated with index.

See Also:
  - Constant Field Values

### COMPRESSED_MEMBER

public static final String COMPRESSED_MEMBER
Name of the member that indicates whether the column needs to be compressed.

See Also:
  - Constant Field Values

## Constructor Details

### ColumnHint

public ColumnHint()

## Method Details

### getStructName

public String getStructName()
Description copied from interface: `IStructure`
Returns the name of the structure definition. The name is the one used to define the structure in the meta-data dictionary.

Returns:
  the internal name of the structure a defined in the meta-data dictionary.

### validate

public List<SemanticException> validate(org.eclipse.birt.report.model.core.Module module, org.eclipse.birt.report.model.core.DesignElement element)
Validates this structure. The following are the rules:

- The column name is required.

Overrides:
  `validate` in class `org.eclipse.birt.report.model.core.Structure`
Parameters:
  `module` - the module
  `element` - the element contains this structure
Returns:
  the semantic error list
See Also:
  - `Structure.validate(Module, org.eclipse.birt.report.model.core.DesignElement)`

### handle

public StructureHandle handle(SimpleValueHandle valueHandle, int index)
Description copied from class: `org.eclipse.birt.report.model.core.Structure`
Creates the specific handle of this structure. This handle is always created.

Specified by:
  `handle` in class `org.eclipse.birt.report.model.core.Structure`
Parameters:
  `valueHandle` - the value handle of this structure list property this structure is in
  `index` - the position of this structure in structure list
Returns:
  the handle of this structure.